#ifndef U_H
#define U_H

typedef struct
{
  int rank;
  int size;
  int nx;
  int ny;
  int itmax;
  int n_bytes;
  double hx, hy;
  double c0, c1, c2;
} params;


params init_params(int itmax, int nx, int ny, double hx, double hy, int rank, int size);

void init_grids(params p, double*** f, double*** u, double*** u_new, double*** u_exact);

void deinit_grids(double** f, double** u, double** u_new, double** u_exact);

void write_grid(char* filename, params p, double** f);

double error(params p, double** u, double** u_new);

void update_u(params p, double** u, double** f, double** u_new);

#endif

